apiVersion: unfurl/v1alpha1
kind: Ensemble
spec:
  deployment_blueprints:
    gcp:
      title: Google Cloud Platform - Compute Engine
      cloud: unfurl.relationships.ConnectsTo.GoogleCloudProject
      description: Deploy using Google Compute Engine
      resource_templates:
        # dockerhost:
        #   type: unfurl.nodes.DockerComputeHost
        the_app: 
          type: WireGuard
          properties:
            #allow_empty_password: "yes"
            peers: 10
            puid: 1000
            pgid: 1000
            tz: "Europe/London"
          requirements:
            - container:
                node: container_service

    aws:
      title: Amazon Web Services - EC2
      cloud: unfurl.relationships.ConnectsTo.AWSAccount
      description: Deploy using Amazon Elastic Compute Cloud (EC2)
      resource_templates:
        dockerhost:
          type: unfurl.nodes.DockerComputeHost
    selfhosted:
      title: Local Development
      cloud:
      description: Deploy onto your own development machines.
      resource_templates:
        dockerhost:
          type: unfurl.nodes.LocalDockerHost
        mariadb-dockerhost:
          type: unfurl.nodes.LocalDockerHost
        the_app:
          type: WireGuard
          properties:
            peers: 10
            puid: 1000
            pgid: 1000
            tz: "Europe/London"

  service_template:
    description:
    metadata:
      template_name: WireGuard
      template_author:
      template_version: 0.1
      livePreview: #url to a live preview
      image: # url to image
      sourceCodeUrl: # url to the source code repository
      deployments: 0
      webUrl: # url to the source project
      

    repositories:
      types:
        url: https://gitlab.com/onecommons/unfurl-types

    imports:
      - file: service-template.yaml
        repository: types

    node_types:
      WireGuard:
        derived_from: unfurl.nodes.DockerComputeHost
        requirements:
          - container: container_service   
        properties:
          puid: 
            metadata:
              computed: true
            type: integer
            required: true 
          pgid: 
            metadata:
              computed: true
            type: integer
            required: true 
          tz: 
            metadata:
              computed: true
            type: string
            required: true 
          peers:
            metadata:
              computed: true
            type: integer
            required: true     
        interfaces:
          Mock:
            operations:
              configure:
                implementation: Template
                inputs:
                  dryrun: true
                  resultTemplate:
                    attributes:
                      url: https://ghost-demo.opencloudservices.dev

    topology_template:
      substitution_mappings:
          node: the_app

      node_templates:
        dockerhost: 
          type: unfurl.nodes.LocalDockerHost

        the_app:
          type: WireGuard
          properties:
            peers: 10
            puid: 1000
            pgid: 1000
            tz: "Europe/London"
            

        container_service:
          type: unfurl.nodes.ContainerService
          properties:
            container:
              image: lscr.io/linuxserver/wireguard
              ports:
                - 51820:51820/udp
              environment:
                PEERS:
                  eval: .configured_by::peers
                PUID:
                  eval: .configured_by::puid
                PGID:
                  eval: .configured_by::pgid
                TZ:
                  eval: .configured_by::tz
          requirements:
            - host:
                # dockerhost is defined in deployment blueprint
                node: dockerhost